'use strict';

var _reactTransformHmr2 = require('react-transform-hmr');

var _reactTransformHmr3 = _interopRequireDefault(_reactTransformHmr2);

var _react = require('react');

var _reactTransformCatchErrors2 = require('react-transform-catch-errors');

var _reactTransformCatchErrors3 = _interopRequireDefault(_reactTransformCatchErrors2);

var _redboxReact = require('redbox-react');

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react2 = _interopRequireDefault(_react);

var _ripple = require('../ripple');

var _ripple2 = _interopRequireDefault(_ripple);

var _utilsEvents = require('../utils/events');

var _utilsEvents2 = _interopRequireDefault(_utilsEvents);

var _style = require('./style');

var _style2 = _interopRequireDefault(_style);

var _components = {
  _$Checkbox: {
    displayName: 'Checkbox'
  }
};

var _reactComponentWrapper = (0, _reactTransformHmr3['default'])({
  filename: 'components/checkbox/index.jsx',
  components: _components,
  locals: [module],
  imports: [_react]
});

var _reactComponentWrapper2 = (0, _reactTransformCatchErrors3['default'])({
  filename: 'components/checkbox/index.jsx',
  components: _components,
  locals: [],
  imports: [_react, _redboxReact]
});

function _wrapComponent(uniqueId) {
  return function (ReactClass) {
    return _reactComponentWrapper2(_reactComponentWrapper(ReactClass, uniqueId), uniqueId);
  };
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var Checkbox = (function (_React$Component) {
  _inherits(Checkbox, _React$Component);

  function Checkbox() {
    var _this = this;

    _classCallCheck(this, _Checkbox);

    _get(Object.getPrototypeOf(_Checkbox.prototype), 'constructor', this).apply(this, arguments);

    this.state = {
      checked: this.props.checked
    };

    this.componentWillReceiveProps = function (next_props) {
      console.log('componentWillReceiveProps', next_props.checked);
      // this.setState({ checked: next_props.checked });
    };

    this.handleChange = function (event) {
      _this.setState({ checked: !_this.state.checked }, function () {
        if (_this.props.onChange) _this.props.onChange(event, _this);
      });
    };

    this.handleClick = function (event) {
      _utilsEvents2['default'].pauseEvent(event);
      if (!_this.props.disabled) _this.handleChange(event);
    };

    this.handleMouseDown = function (event) {
      if (!_this.props.disabled) _this.refs.ripple.start(event);
    };

    this.handleInputClick = function (event) {
      _utilsEvents2['default'].pauseEvent(event);
    };
  }

  _createClass(Checkbox, [{
    key: 'render',
    value: function render() {
      var fieldClassName = _style2['default'].field;
      var checkboxClassName = _style2['default'].check;
      if (this.state.checked) checkboxClassName += ' ' + _style2['default'].checked;
      if (this.props.disabled) fieldClassName += ' ' + _style2['default'].disabled;
      if (this.props.className) fieldClassName += ' ' + this.props.className;

      return _react2['default'].createElement(
        'label',
        {
          'data-react-toolbox': 'checkbox',
          className: fieldClassName,
          onClick: this.handleClick
        },
        _react2['default'].createElement('input', _extends({}, this.props, {
          ref: 'input',
          type: 'checkbox',
          className: _style2['default'].input,
          checked: this.state.checked,
          onChange: this.handleChange,
          onClick: this.handleInputClick
        })),
        _react2['default'].createElement(
          'span',
          { 'data-role': 'checkbox', className: checkboxClassName, onMouseDown: this.handleMouseDown },
          _react2['default'].createElement(_ripple2['default'], { ref: 'ripple', 'data-role': 'ripple', className: _style2['default'].ripple, spread: 3, centered: true })
        ),
        this.props.label ? _react2['default'].createElement(
          'span',
          { 'data-role': 'label', className: _style2['default'].text },
          this.props.label
        ) : null
      );
    }
  }, {
    key: 'blur',
    value: function blur() {
      this.refs.input.blur();
    }
  }, {
    key: 'focus',
    value: function focus() {
      this.refs.input.focus();
    }
  }, {
    key: 'getValue',
    value: function getValue() {
      return this.state.checked;
    }
  }, {
    key: 'setValue',
    value: function setValue(value) {
      this.setState({ checked: value });
    }
  }], [{
    key: 'propTypes',
    value: {
      checked: _react2['default'].PropTypes.bool,
      className: _react2['default'].PropTypes.string,
      disabled: _react2['default'].PropTypes.bool,
      label: _react2['default'].PropTypes.any,
      name: _react2['default'].PropTypes.string,
      onBlur: _react2['default'].PropTypes.func,
      onChange: _react2['default'].PropTypes.func,
      onFocus: _react2['default'].PropTypes.func
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      checked: false,
      className: '',
      disabled: false
    },
    enumerable: true
  }]);

  var _Checkbox = Checkbox;
  Checkbox = _wrapComponent('_$Checkbox')(Checkbox) || Checkbox;
  return Checkbox;
})(_react2['default'].Component);

exports['default'] = Checkbox;
module.exports = exports['default'];